/*
 * mtftpd - Multi thread server daemon
 * Copyright (C) 2002 Francisco J. Oviedo Alvarez <foviedoa@teleline.es>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MT_BUFFER_H
#define MT_BUFFER_H

struct buffer {
	char *dat;		/* data buffer */
	size_t as;		/* size of real data */
	size_t ts;		/* total size of buffer */
	size_t is;		/* increment size of buffer */
};

typedef struct buffer buffer_t;
typedef struct buffer *buffer_pt;

/* prot */

buffer_pt buffer_create(size_t);
void buffer_init(buffer_pt);
void buffer_destroy(buffer_pt);
int buffer_add(buffer_pt, char *, size_t);
char *buffer_getdata(buffer_pt);
size_t buffer_getsize(buffer_pt);
void buffer_sort(buffer_pt, size_t, int(*)());

#endif	/* MT_BUFFER_H */
