/*
 * mtftpd - Multi thread server daemon
 * Copyright (C) 2002 Francisco J. Oviedo Alvarez <foviedoa@teleline.es>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MT_CMD_H
#define MT_CMD_H

#include <sys/stat.h>
#include <conf.h>
#include <mtftpd.h>
#include <buffer.h>

struct cmds {
	char name[5];
	void (*func)(session_pt, char *);
	unsigned int flags;
	char shelp[60];
};

typedef struct cmds cmds_t;
typedef struct cmds *cmds_pt;

#define MT_CMD_F_NULL		0x00
#define MT_CMD_F_LOGIN		0x01
#define MT_CMD_F_PARAM		0x02
#define MT_CMD_F_NPARAM		0x04
#define MT_CMD_F_NIMPLE		0x08

/* ls options */
#define MT_LS_OPT_NULL		0x00
#define MT_LS_OPT_A			0x01
#define MT_LS_OPT_L			0x02
#define MT_LS_OPT_F			0x04
#define MT_LS_OPT_R			0x08

/* proto */

void parser(session_pt, char *, char *);
void mt_ls(session_pt, char *, int);
void mt_format_ls(buffer_pt, struct stat *, char *, char *, int);
void mt_stor_appe(session_pt, char *, int);
void mt_listnlist(session_pt, char *, int);
int mt_ls_param(char **);
void mt_do_dir(session_pt, buffer_pt, char *, int);

#define CMD_P(cmd) void cmd_##cmd##(session_pt ses, char *param)

CMD_P(user);
CMD_P(pass);
CMD_P(quit);
CMD_P(noop);
CMD_P(syst);
CMD_P(type);
CMD_P(mode);
CMD_P(port);
CMD_P(pwd);
CMD_P(cwd);
CMD_P(cdup);
CMD_P(rmd);
CMD_P(mkd);
CMD_P(dele);
CMD_P(pasv);
CMD_P(retr);
CMD_P(list);
CMD_P(nlst);
CMD_P(help);
CMD_P(stru);
CMD_P(rnfr);
CMD_P(rnto);
CMD_P(stor);
CMD_P(appe);

#endif	/* MT_CMD_H */
