/*
 * mtftpd - Multi thread server daemon
 * Copyright (C) 2002 Francisco J. Oviedo Alvarez <foviedoa@teleline.es>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MT_CONF_H
#define MT_CONF_H

/* autotools conf header */
#if HAVE_CONFIG_H
#include <config.h>
#endif

#if MT_DEBUG
#define DPRINTF(x) log_msg(x)
#else
#define DPRINTF(x)
#endif

#define LOCK_POOL mt_lock(spool->lock);
#define UNLOCK_POOL mt_unlock(spool->lock);

#if !HAVE_BZERO && HAVE_MEMSET
#define bzero(buff, bytes) ((void)memset((buff), 0, (bytes))
#endif

#define MT_BACKLOG 512 

#define MT_SERV_PORT 21

#define MT_FTP_USER "ftp"
#define MT_FTP_GROUP "ftp"

#define MT_MAX_COMM_BUFF 512
#define MT_MAX_COMM 256

#define MT_MAX_SES 3000	/* max number of concurrent sessions */

#define MT_COMM_TIMEOUT 300
#define MT_DATA_TIMEOUT 300

#define MT_MEM_KEY	(key_t)6969

#define MT_FTPUSERS "/etc/ftpusers"	/* path of ftpusers */

#endif	/* MT_CONF_H */
